;****************************************************************************
;*                     GNU Hell on Earth   ver 0.16 Beta                    *
;*                    A 3D engine for the TI 92 calculator                  *
;*                     Copyright (C) 1998  Mathieu Lacage                   *
;****************************************************************************

;**************************
; a subroutine used by key_test
;**************************

; this routine will modify or not d4 and d7 : this change must be kept
; as these variables are global

check:
   move.l   X,D4              ;  Checks if new position valid ( ie: not in
   move.l   Y,D7              ;  a wall ) 
   asr.l    #6,D4             ;
   asr.l    #_square,D4       ;
   asl.l    #1,D4             ;
   asr.l    #6,D7             ;
   asr.l    #_square,D7       ;
   asl.l    #_world+1,D7      ;
   add.l    D4,D7             ;
   move.w   0(A0,D7),D7       ;
   btst     #0,D7             ;
   beq      \correct          ;
   move.l   X_save,X          ;
   move.l   Y_save,Y          ;
\correct                      ;
   move.l   X,D4              ;
   move.l   Y,D7              ;
   asr.l    #6,D4             ;
   asr.l    #6,D7             ;
   rts

;*************************
; key_test !!!
;*************************
; d0,d1,d2,d3,d5 are modified
; a3,a4 are also modified
; all registers are or kept unmodified
; or are reinitialized before beeing reused... Thus, there is no need for any
; saving...


key_test:
   move.b   #$FF,($60001B)
   move.w   #%111111110,($600018)
   nop
   nop
   nop
   nop
   nop
   nop
   nop
   move.b   ($60001B),d0
   move.b   d0,d1
   not.b    d1
   and.b    #%11111001,d1
   beq      no_key             

hand:
   btst.b   #3,d0
   bne      left          
   btst.b   #4,d0             
   bne      \hand_right
; code
   bra      no_key
\hand_right
   btst     #6,d0
   bne      left
; code
   bra      no_key

left:
   btst.b   #4,d0
   bne      up
   add      #ang_inc,view_ang
   cmp      #ang_360,view_ang
   bcs      up
   sub      #ang_360,view_ang

up:
   btst.b   #5,d0             ;
   bne      right             ;
   move.l   X,X_save
   move.l   Y,Y_save
   move.l   move_x_ptr,A3     ;
   move.l   move_y_ptr,A4     ;
   move.w   view_ang,D2       ;
   move.b   0(A3,D2),D3       ;
   ext.w    D3                ;  Calculates new position
   ext.l    D3                ;
   asl.w    #2,D3             ;
   add.l    D3,X
   move.b   0(A4,D2),D5       ;
   ext.w    D5                ;
   ext.l    D5                ;
   asl      #2,D5             ;
   sub.l    D5,Y
   bsr      check

right:
   btst.b  #6,d0              
   bne      down
   sub      #ang_inc,view_ang
   tst      view_ang
   bpl      down
   add      #ang_360,view_ang

down:
   btst.b   #7,d0
   bne      no_key
   move.l   X,X_save
   move.l   Y,Y_save
   move.l   move_x_ptr,A3     ;
   move.l   move_y_ptr,A4     ;
   move     view_ang,D2       ;
   move.b   0(A3,D2),D3       ;
   ext.w    D3                ;  Calculates new position
   ext.l    D3                ;
   asl.w    #2,D3             ;
   sub.l    D3,X              ;
   move.b   0(A4,D2),D5       ;
   ext.w    D5                ;
   ext.l    D5                ;
   asl      #2,D5             ;
   add.l    D5,Y
   bsr      check

no_key:
  rts

X         dc.l 0
X_save    dc.l 0
Y         dc.l 0
Y_save    dc.l 0


;****************************
; The zap_screen subroutine.. fast clr_scr !!
;****************************

zap_screen:
	movem.l	d0-d7/a0-a6,-(sp)
        move.l   a7,save
        move.l   plane_ptr,a7
        add.l    #$F00,a7
        movem.l zeroes,d0-d7/a0-a6
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times

        move.l  save,a7
	movem.l	(sp)+,d0-d7/a0-a6
	rts

save              dc.l 0
zeroes            dcb.l 15,0



;**************************
; Used to swap between Virtual screens...
; Its variables are included
;**************************
; d0 and a5 are modified but they need not to be saved as they will
; be reinitialized before beeing reused...

 ifne mode-debug_mode

swap_screen:
 move.l   phase,d0
 add.b    #2,d0
 and.b    #4-1,d0
 move.l   d0,phase
 lea      scr_table_hard(pc),a5
 move.w   0(a5,d0),($600010)
 lea      scr_table(pc),a5
 asl.b    #1,d0
 move.l   0(a5,d0),plane_ptr
 rts

phase             dc.l 0

scr_table:
plane_0_ptr       dc.l 0
plane_1_ptr       dc.l 0

scr_table_hard:
plane_1_ptr_hard  dc.w 0
plane_0_ptr_hard  dc.w 0

 endif

;**************************
; The subroutine in charge of getting mem and
; in charge of initializing some variables...
;**************************


init:
 ifne mode-debug_mode
   move.l   #$F08,-(a7)            ;
   jsr      tios::HeapAlloc        ;
   add.l    #4,a7                  ; Ask for the mem necessary to
   tst.w    d0                     ; the virtual screens
   beq      alloc_error            ;
   move.w   d0,handle_number       ;
   tios::DEREF d0,a6               ;

   move.l   A6,D0                  ;
   add.l    #7,D0                  ;
   asr.l    #3,D0                  ;
   move.w   D0,plane_0_ptr_hard    ;  initialize the screen pointers table
   asl.l    #3,D0                  ;
   move.l   D0,plane_0_ptr         ;
   move.l   #tios::main_lcd,d0     ;
   move.l   d0,plane_1_ptr         ;
   asr.l    #3,d0                  ; 
   move.w   d0,plane_1_ptr_hard    ;
   move.l   plane_1_ptr,plane_ptr
  endif
  ifeq mode-debug_mode
   move.l   #tios::main_lcd,d0     ;
   move.l   d0,plane_ptr           ;
  endif

   bsr      zap_screen             ; clear the screen

   move.w   #$700,d0               ; disable interrupts, and put
   trap     #1                     ; the old int mask in int_mask
   move.l   d0,int_mask            ;

   movem.l  zeroes,d0-d7/a0-a6
   lea      tables(pc),A1
   move.l   A1,tan_128_ptr
   add.l    #450,A1
   move.l   A1,inv_tan_128_ptr
   add.l    #450,A1
   move.l   A1,tan_64_ptr
   add.l    #450,A1
   move.l   A1,inv_tan_64_ptr
   add.l    #450,A1
   move.l   A1,inv_cos_128_ptr
   add.l    #450,A1
   move.l   A1,inv_sin_128_ptr

   lea      fish(pc),A1
   move.l   A1,fish_ptr
   lea      move_x(pc),A1
   move.l   A1,move_x_ptr
   lea      move_y(pc),A1
   move.l   A1,move_y_ptr
   lea      world(pc),A0
   move.l   fish_ptr,A2

   move.l   #100*64,X
   move.l   #100*64,Y
   move.l   #100,D4
   move.l   #100,D7
   move.w   #700,view_ang
   rts

 ifne mode-debug_mode
handle_number     dc.w 0       ; the handle number used by the virtual screen
 endif

